



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java Core 学习笔记——3.char/Unicode/代码点/代码单元</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java Core 学习笔记——3.char/Unicode/代码点/代码单元</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 14:43:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>通用字符集（UCS）</h2>
<hr />
<p>UCS是由ISO制定的ISO 10646（或称ISO/IEC 10646）标准所制定的标准字符集。</p>
<p>UCS包括了其他所有的字符集（包含了已知语言的所以字符）。</p>
<p>ISO/IEC 10646定义了一个31位的字符集（首位恒定为0，占用4字节）。</p>
<h2>Unicode（万国码、国际码、统一码、单一码）</h2>
<hr />
<h3>编码方式：</h3>
<p>Unicode编码空间从&ldquo;U+0000&rdquo;到&ldquo;U+10FFFF&rdquo;（共1112064个码位），Unicode的编码空间划为17个平面，每个平面包含2<sup>16</sup>（65536）个码位。17个平面码位可表示为&ldquo;U+xx0000&rdquo;到&ldquo;U+xxFFFF&rdquo;（xx表示十六进制从&nbsp;&nbsp;&nbsp; 00<sub>16</sub>到10<sub>16</sub>，共计17个平面）。第一个平面称为基本多文种平面，其他平面为辅助平面。</p>
<p>Unicode目前实际应用的版本对应于UCS-2，使用16位的编码空间（占用2字节，最多可表示2<sup>16</sup>=65536个字符），但当前版本并未完全使用这16位编码，仍保留了大量空间以作为特殊使用或将来扩展。</p>
<p>上述16位Unicode字符构成了基本多文种平面（属于UCS级别3，简称BMP，又称&ldquo;零号平面&rdquo;）。最新（未实际广泛使用）的Unicode版本又定义了16个辅助平面，共占用4字节编码空间，与UCS-4（未来版本将会达到，UCS-4为31位字符集，加上首位恒为0,共占32位，4字节，最多可表示2<sup>31</sup>个字符）一致。</p>
<p>基本多文种平面的字符的编码为&ldquo;U+hhhh&rdquo;（h为一个十六进制数字），与UCS-2编码完全相同。同一字符UCS-2对应的UCS-4编码后两字节相同，前两字节均为0。</p>
<h3>实现方式（UTF）：</h3>
<p>在不同平台上，为了节省空间，Unicode编码的实现方式不同。</p>
<p>例如，对一个仅含基本7位ASCⅡ字符的Unicode文件，如果每个字符以2字节的原Unicode编码方式传输将浪费巨大空间。对于这种情况，可以采用UTF-8编码（占用一个字节，后7位为原ASCⅡ编码，首位补0）。对于ASCⅡ与其他Unicode字符混混的情况，将通过算法转换，每个字符使用1-4个字节编码。</p>
<h2>代码点/代码单元（JDK 5.0）</h2>
<hr />
<p>代码点（code point）是指与一个编码表中的某个字符对应的代码值（Unicode编码方式）。</p>
<p>Java中，char类型用UTF-16编码描述一个代码单元（code unit）。</p>
<p>UTF-16采用不同长度的编码表示所有的Unicode代码点。在基本多文种平面，每个字符用16位表示（通常称为一个代码单元）；辅助字符采用一对连续的代码单元（32位）表示。</p>
<h2>参考链接</h2>
<hr />
<ul><li>Unicode：<a href="http://zh.wikipedia.org/wiki/Unicode" rel="external nofollow noreferrer">http://zh.wikipedia.org/wiki/Unicode</a></li>
<li>UCS：<a href="http://zh.wikipedia.org/wiki/%E9%80%9A%E7%94%A8%E5%AD%97%E7%AC%A6%E9%9B%86" rel="external nofollow noreferrer">http://zh.wikipedia.org/wiki/%E9%80%9A%E7%94%A8%E5%AD%97%E7%AC%A6%E9%9B%86</a></li>
<li>UTF-16：<a href="http://zh.wikipedia.org/wiki/UTF-16" rel="external nofollow noreferrer">http://zh.wikipedia.org/wiki/UTF-16</a></li></ul>
<h2>写在最后</h2>
<hr />
<p>这次的排版借鉴了维基百科的排版方式，前三次的笔记，每次排版都不太一样 XD</p>
<p>UCS、Unicode、UTF，越看越晕，越写越不知道在写什么。怎么写的和Java一点关系都没有啊！</p>
<p>发现好像可以用一句话直接总结：Java里的字符串就是由char类型序列，一个个的代码点表示的，大部分常用字符（基本多文种平面）的代码点使用一个代码单元（2字节），辅助字符则为一对代码单元（4字节）。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4w709z.html">iOS--碎片知识锦集</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlo3n0q.html">HTML5页面绘图</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r7d748.html">Pycharm注册码（2016&period;2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495z2yv9.html">Git学习笔记（6）&mdash;&mdash;Bug和Feature分支</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgrr69.html">该如何理解AMD ，CMD，CommonJS规范--javascript模块化加载学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1mv259.html">java集合TreeMap应用---求一个字符串中，每一个字母出现的次数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wlwj8.html">How to include JavaScript file in JSF</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3n4x9.html">Invalidate、RedrawWindow与UpdateWindow</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxxwj8.html">&period;net mvc datatables中orderby动态排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde4jxq.html">Android开源资料大集合&lowbar;架构&amp;amp&semi;UI</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rg1g8.html">优秀的 Android Studio 插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxdrw8.html">【笔记】虚拟机用Xshell登陆报错&OpenCurlyDoubleQuote;ssh服务器拒绝了密码&rdquo;解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zmx509.html">UI进阶 即时通讯之XMPP登录、注册</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxyeo8.html">iOS AFNetworking使用技巧与问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp46dvq.html">union 的两个用处</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3yed9.html">java代码理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5mln7q.html">centos7 tar&period;xz格式文件的解压方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdry4d9.html">Guava Immutable 不可变集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll45lxq.html">phpstom pojie</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vzmm2q.html">前端学PHP之会话Session</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pjm66z9.html">ES6入门之Symbol</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde516j9.html">Mongodb数据操作基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wx173q.html">UBoot常用命令手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde54ez9.html">使用git建立本地仓储管理代码【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xpozm8.html">《OD大数据实战》MapReduce实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd4e0d8.html">poj 2192 &lpar;DP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmog5x9.html">用FireMonkey写QQ皮肤</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wxo0vq.html">适用于Firemonkey的Json解析对象XsuperObject使用方法介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/96omxxv9.html">POJ 3693 &lpar;后缀数组&rpar; Maximum repetition substring</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m74xjq.html">UVa 11100 The Trip&comma; 2007</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
